@reexport module SubSystems

using UUIDs
using LightGraphs, LinearAlgebra, GraphPlot
import ..Systems: checkandshow
import ..Systems.StaticSystems: Memory, Coupler, StaticSystem
import ....Components.ComponentsBase: @generic_system_fields, AbstractSubSystem, AbstractDynamicSystem
import ......Jusdl.Connections: Link, Bus, connect, disconnect, getmaster
import ......Jusdl.Utilities: Callback

include("subsystem.jl")
include("network.jl")

export SubSystem, Network, uniformconnectivity, cgsconnectivity, clusterconnectivity, coupling, gplot, topology
export nodes, numnodes, dimnodes
export deletelink, changeweight, maketimevarying, openinputbus

end